Documentation

​
​

Development

User Acquisition

Monetization

Industry

Content Delivery Management API

v1

Supported
​

Content Delivery Management API

v1

Supported
​

Unity Services Web APIs
​
​
Content Delivery Management API
  • Overview
  • Environments
  • Authentication
  • Workflow for Uploading Content to a Bucket
  • Permissions
  • Generate difference between releases
  • Useful links & Information
Endpoints
  • Badges
  • BucketAccessTokens
  • Buckets
  • Content
  • Entries
  • Environments
  • Orgs
  • Permissions
  • Releases

Content Delivery Management API

Overview

Cloud Content Delivery (CCD) is a managed cloud service that hosts and delivers content to your applications users worldwide without having to reinstall a new version of the application. The service is fully integrated into the Unity development platform, saving you months of building and maintaining your own similar service. CCD is most valuable for content-rich, live games or applications that require content updates on a regular basis. It is intended to be used by developers at build time for managing content.

Environments

Environments can be created in the Unity Developer Dashboard. A project can exist in several different environments with completely different data sets. Org and User routes are not impacted by environments, but any project or bucket level route is. To find a list of environments for your project and their corresponding IDs visit the Dashboard. If you signed up for UGS Beta, click on Projects. Find your Project and then click on Environments under Project Settings. When environments were introduced all existing data was put into the 'production' environment. If you did not sign up, you can see the environment Id in the LiveOps page. In the Cloud Content Delivery section, click on buckets and you will see the Environment ID in the GUIDS tabs. If you make an API call without an environment ID or environment name you will get data from that default - 'production' - environment.
Routes in the management API take an environment ID. Routes in the client API take an environment name which is then resolved by the API to the proper ID.
All of the old routes without an environment specified have been marked deprecated. They still work and will continue to be supported. We just wanted to make it clear in the documentation which routes you should use going forward.

Authentication

The Content Delivery Management API requires an API key associated with your Unity developer account. To access your API Key, please visit the developer dashboard. To authenticate requests, include a Basic Authentication header as a base64-encoded string 'username:password', using your API key as the password (and empty username). For example, an API key value of
d6d2c026bac44b1ea7ac0332694a830e
would include an Authorization header like
Authorization Basic OmQ2ZDJjMDI2YmFjNDRiMWVhN2FjMDMzMjY5NGE4MzBl
.
The Content Delivery Management API is deprecating API Key Authentication and now recommends using Service Account Authentication instead.
To create a new service account please follow the instructions available in the Create a service account section of the Service Account Authentication documentation.
Under Organization roles, you must assign the Cloud Content Delivery API Public Editor role to your service account to grant read and write access to public endpoints of CCD Management API.
To use service account please follow the instructions available in the Authenticate an API using service account credentials section of the Service Account Authentication documentation.
As mentioned in the documentation linked above, for CCD Management API endpoints use
https://services.api.unity.com/ccd/management/v1/
as the URL host + base path.

Workflow for Uploading Content to a Bucket

If a user wants to upload content to a Bucket, they need to first create a new Entry for that bucket and using that Bucket ID and Entry ID they can upload the content(file).
Create upload schema
If a user wants to upload new content for an existing file path, they first update the Entry for the file then upload the content.
Update upload schema
We recommend using the Entry parameter signed_url set to "true" when creating or updating an Entry to get back a signed URL that can be use to upload the content directly to the cloud storage. The signed URL will be returned in the response Entry parameter signed_url. The content can then be uploaded using a request like this:
curl -i -X PUT -H \'Content-Type: CONTENT_TYPE_HERE\' --upload-file \'FOLDER/PATH/TO/YOUR/FILE/samplefile.txt\' \'SIGNED_URL_HERE\'
Note that signed URLs are valid for 5 mins and cannot be used for chunked or resumable uploads.

Permissions

A Permission is set on a bucket and is composed of a role and an action that can be allowed or denied. Some actions require permissions to be performed. The available roles are 'user' for the management API and 'client' for the client API. The current actions possible are 'write' and 'list-releases'. For example, 'list-releases' is currently denied by default in the client API. To enable the list releases endpoints for the client API, a permission must be added with the role 'client', the action 'list-releases' and the permission 'allow'.

Generate difference between releases

When you create a release, CCD automatically generates a difference between the new release and the previous one. However, if you want to get the diff between two versions with a jump (for example, /?fromreleasenum=0&toreleasenum=4), and it was never previously generated, then you must calculate the diff asynchronously. Note: The difference releases entries route returns an empty set if the difference was not generated first. First, generate the diff using the following route: /diff/releases/?fromreleasenum=0&toreleasenum=4 It returns a response with a flag, for example:
{ "unchanged": 0, "add": 0, "update": 0, "delete": 0, "loading": true }
The loading flag is true if the task is not yet completed. To learn the status of the task, poll the releases' routes until the flag is false, as in the following example:
{ "unchanged": 1, "add": 1, "update": 2, "delete": 0, "loading": false }
You could now see the entries listed using the following route: {bucket_id}/diff/releases/entries/?fromreleasenum=0&toreleasenum=4

Useful links & Information

  • For more information on CCD, visit Unity CCD Documentation.
  • The Content Delivery can also be managed using the CLI. For more information, visit Unity CCD command-line interface.
  • Unity Cloud Build contains an integration with CCD. For more information, visit Unity Cloud Build documentation.
Download OpenAPI specification:

Delete a bucket


Removes a bucket by ID. All files that are no longer referred to by another bucket in a project are removed.

Path parameters for "Delete a bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Delete a bucket":

Code samples for "Delete a bucket":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get a bucket


Gets the bucket details by ID.

Path parameters for "Get a bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Get a bucket":

Code samples for "Get a bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}"

Response example

{ "attributes": { "promote_only": true }, "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "created": "2024-01-01T00:00:00Z", "description": "Something that describes this bucket", "environment_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "environment_name": "test_environment", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "last_release": { "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0 }, "name": "android_staging", "permissions": { "bucket_promote": false, "bucket_read": true, "bucket_release": false, "bucket_write": false }, "private": true, "projectguid": "123e4567-e89b-12d3-a456-426655440000"}

Update a bucket


Updates the bucket details by ID.

Path parameters for "Update a bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Update a bucket"

Media Type:
application/json

description

string
example: Something that describes this bucket
No description

name

string
example: android_staging
No description

HTTP response status codes for "Update a bucket":

Code samples for "Update a bucket":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "description": "Something that describes this bucket", "name": "android_staging"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}"

Response example

{ "attributes": { "promote_only": true }, "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "created": "2024-01-01T00:00:00Z", "description": "Something that describes this bucket", "environment_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "environment_name": "test_environment", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "last_release": { "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0 }, "name": "android_staging", "permissions": { "bucket_promote": false, "bucket_read": true, "bucket_release": false, "bucket_write": false }, "private": true, "projectguid": "123e4567-e89b-12d3-a456-426655440000"}

List bucket access tokens


List bucket access tokens.

Path parameters for "List bucket access tokens"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "List bucket access tokens"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

HTTP response status codes for "List bucket access tokens":

Code samples for "List bucket access tokens":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/accesstokens"

Response example

[ { "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string" }]

Create bucket access token


Create a bucket access token. By default, bucket access tokens grant access to all content in the bucket including all releases. To restrict access to a single release, specify a 'releaseid' in the post body.

Path parameters for "Create bucket access token"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create bucket access token"

Media Type:
application/json

description

string
example: Shared with internal devs
No description

releaseid

string
example: 123e4567-e89b-12d3-a456-426655440000
If not specified, the access token will be valid for all releases in the bucket.

HTTP response status codes for "Create bucket access token":

Code samples for "Create bucket access token":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "description": "Shared with internal devs", "releaseid": "123e4567-e89b-12d3-a456-426655440000"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/accesstokens"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Delete a bucket access token


Delete a bucket's access token by key.

Path parameters for "Delete a bucket access token"

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

HTTP response status codes for "Delete a bucket access token":

Code samples for "Delete a bucket access token":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

get bucket access token


Get bucket access token info.

Path parameters for "get bucket access token"

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

HTTP response status codes for "get bucket access token":

Code samples for "get bucket access token":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Update bucket access token info


Update bucket access token info.

Path parameters for "Update bucket access token info"

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

Request body for "Update bucket access token info"

Media Type:
application/json

description

string
example: Shared with internal devs
No description

HTTP response status codes for "Update bucket access token info":

Code samples for "Update bucket access token info":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "description": "Shared with internal devs"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Get badges


Gets all badges for a bucket.

Path parameters for "Get badges"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get badges"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

name

string
resource name

releasenum

string
release number

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get badges":

Code samples for "Get badges":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/badges"

Response example

[ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 }]

Assign a badge


Assigns a badge to a release.

Path parameters for "Assign a badge"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Assign a badge"

Media Type:
application/json

name

string
required
example: QATesting
No description

releaseid

string
example: 123e4567-e89b-12d3-a456-426655440000
No description

releasenum

integer
example: 2
No description

HTTP response status codes for "Assign a badge":

Code samples for "Assign a badge":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 2}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/badges"

Response example

{ "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0}

Delete a badge


Removes a badge by name.

Path parameters for "Delete a badge"

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

HTTP response status codes for "Delete a badge":

Code samples for "Delete a badge":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/badges/{badgename}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get badge


Gets a badge by name.

Path parameters for "Get badge"

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

HTTP response status codes for "Get badge":

Code samples for "Get badge":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/badges/{badgename}"

Response example

{ "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0}

Batch delete entries


Removes up to 200 entries from a given bucket. When DELETE is called on an entry we just mark it as deleted but all previous versions of the file still exist. No file content is removed.

Path parameters for "Batch delete entries"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Batch delete entries"

Media Type:
application/json
Array Type:
[ { "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

HTTP response status codes for "Batch delete entries":

Code samples for "Batch delete entries":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '[ { "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/batch/delete/entries"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Batch Create or Update Entries


Creates or update up to 200 entries in a given bucket via Signed URLs; Will update the entry if the path already exists. Content Hash and Content Size are not mandatory.

Path parameters for "Batch Create or Update Entries"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Batch Create or Update Entries"

Media Type:
application/json
Array Type:
[ { "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle" }]

HTTP response status codes for "Batch Create or Update Entries":

Code samples for "Batch Create or Update Entries":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '[ { "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle" }]' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/batch/entries"

Response example

[ { "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z" }]

Get counts of changes between releases


Gets the change count between two releases.

Path parameters for "Get counts of changes between releases"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get counts of changes between releases"

fromreleaseid

string
From Release ID, specify 'latest' to use the most recent release. Either fromreleaseid or fromreleasenum can be specified, but not both.

fromreleasenum

integer
From Release Number. To query against an empty bucket you may set fromreleasenum to zero. Either fromreleaseid or fromreleasenum can be specified, but not both.

toreleaseid

string
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

toreleasenum

integer
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

HTTP response status codes for "Get counts of changes between releases":

Code samples for "Get counts of changes between releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/diff/releases"

Response example

{ "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5}

Get changed entries between releases


Gets the list of changed entries between two releases.

Path parameters for "Get changed entries between releases"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get changed entries between releases"

fromreleaseid

string
From Release ID, specify 'latest' to use the most recent release. Either fromreleaseid or fromreleasenum can be specified, but not both.

fromreleasenum

integer
From Release Number. To query against an empty bucket you may set fromreleasenum to zero. Either fromreleaseid or fromreleasenum can be specified, but not both.

toreleaseid

string
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

toreleasenum

integer
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

path

string
Path

include_states

array
Include change states, one or more can be specified. The default is all states.

content_type

string
content type

label

string
Label

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get changed entries between releases":

Code samples for "Get changed entries between releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/diff/releases/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get counts of changes since last release


Gets change count since the last release.

Path parameters for "Get counts of changes since last release"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Get counts of changes since last release":

Code samples for "Get counts of changes since last release":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/diff/unreleased"

Response example

{ "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5}

Get changed entries since last releases


Gets changed entries since the last release.

Path parameters for "Get changed entries since last releases"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get changed entries since last releases"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

path

string
Path

include_states

array
Include change states, one or more can be specified. The default is all states.

label

string
Label

content_type

string
content type

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get changed entries since last releases":

Code samples for "Get changed entries since last releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/diff/unreleased/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get entries for bucket


Gets all entries for a given bucket. Entries can be searched/queried by path or label. For example, to search by path you can do "/buckets/{bucketid}/entries/?path=asset.bundle" To search by label you can do "/buckets/{bucketid}/entries/?label=android" To search by path and label both you can do "/buckets/{bucketid}/entries/?path=asset.bundle&label=android". In this case the entries will need to match both filters.

Path parameters for "Get entries for bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get entries for bucket"

page

integer
Current Page

starting_after

string
returns items listed after the named ID

per_page

integer
default: 10
Items Per Page

path

string
Path

label

string
Label

content_type

string
content type

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get entries for bucket":

Code samples for "Get entries for bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries"

Response example

[ { "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z" }]

Create entry


Creates a new entry for a given bucket. Content Hash and Content Size are not mandatory when using Signed URLs.

Path parameters for "Create entry"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create entry"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

path

string
required
example: ios/character1.bundle
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Create entry":

Code samples for "Create entry":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle", "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Delete entry


Removes a single entry for a given bucket. When DELETE is called on an entry we just mark it as deleted but all previous versions of the file still exist. No file content is removed.

Path parameters for "Delete entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

HTTP response status codes for "Delete entry":

Code samples for "Delete entry":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get entry


Gets a single entry for a given bucket.

Path parameters for "Get entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

HTTP response status codes for "Get entry":

Code samples for "Get entry":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Update entry


Updates a single entry for a given bucket.

Path parameters for "Update entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Request body for "Update entry"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Update entry":

Code samples for "Update entry":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Get content by entryid


Gets the content for a given entry.

Path parameters for "Get content by entryid"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Get content by entryid"

versionid

string
Version ID

HTTP response status codes for "Get content by entryid":

Code samples for "Get content by entryid":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

"string"

Get content status by entryid


Gets the status of uploaded content.

Path parameters for "Get content status by entryid"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Get content status by entryid"

versionid

string
Version ID

HTTP response status codes for "Get content status by entryid":

Code samples for "Get content status by entryid":

Request example

curl -X HEAD \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Upload content for entry


Uploads or resumes uploading content for an entry. There are two content-types supported for uploading content for an entry. One is "multipart/form-data" which is not available through the Internal API and the other is "application/offset+octet-stream" which uses the tus protocol. Please refer to https://tus.io/ for more details. Note that the Internal API also has a 100mb limitation. This API is now deprecated. We recommend using signed URLs as it uploads directly to the cloud storage and has no size limitations. Signed URLs are returned by the create and/or update entry endpoints by using the entry parameter signed_url set to "true".

Path parameters for "Upload content for entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Upload content for entry"

versionid

string
Version ID

Request body for "Upload content for entry"

Media Type:
multipart/form-data

file

string
required
File content

HTTP response status codes for "Upload content for entry":

Code samples for "Upload content for entry":

Request example

curl -X PATCH \ -H "Content-Type: multipart/form-data" \ -d '{"file":"string"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Create content upload for TUS


Simply returns the content upload URL in the Location header for TUS (a resumable file upload implementation). This endpoint is not required for most file uploads.

Path parameters for "Create content upload for TUS"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Create content upload for TUS"

versionid

string
Version ID

HTTP response status codes for "Create content upload for TUS":

Code samples for "Create content upload for TUS":

Request example

curl -X POST \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get entry versions


Gets all versions of an entry.

Path parameters for "Get entry versions"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Get entry versions"

label

string
Label

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

HTTP response status codes for "Get entry versions":

Code samples for "Get entry versions":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/versions"

Response example

[ { "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get entry version


Gets a specific version of an entry.

Path parameters for "Get entry version"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

versionid

string
required
Version ID

projectid

string
required
Project ID

HTTP response status codes for "Get entry version":

Code samples for "Get entry version":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/versions/{versionid}"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Get content for version of entry


Gets the content for a specific version of an entry.

Path parameters for "Get content for version of entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

versionid

string
required
Version ID

projectid

string
required
Project ID

HTTP response status codes for "Get content for version of entry":

Code samples for "Get content for version of entry":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/versions/{versionid}/content"

Response example

"string"

Get content status for version of entry


Gets the status of uploaded content for a specific version of an entry.

Path parameters for "Get content status for version of entry"

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

versionid

string
required
Version ID

projectid

string
required
Project ID

HTTP response status codes for "Get content status for version of entry":

Code samples for "Get content status for version of entry":

Request example

curl -X HEAD \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entries/{entryid}/versions/{versionid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get entry by path


Gets a single entry by path for a given bucket.

Path parameters for "Get entry by path"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get entry by path"

path

string
required
Path

versionid

string
Version ID

HTTP response status codes for "Get entry by path":

Code samples for "Get entry by path":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entry_by_path"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Create or update entry by path


Creates a new entry for a given bucket; can update the entry if the path already exists. Content Hash and Content Size are not mandatory when using Signed URLs.

Path parameters for "Create or update entry by path"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Create or update entry by path"

path

string
required
Path

updateIfExists

boolean
default: false
Set to 'true' if you want to update the existing entries

Request body for "Create or update entry by path"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Create or update entry by path":

Code samples for "Create or update entry by path":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entry_by_path"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Update entry by path


Update the entry by path

Path parameters for "Update entry by path"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Update entry by path"

path

string
required
Path

Request body for "Update entry by path"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Update entry by path":

Code samples for "Update entry by path":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/entry_by_path"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

delete a permission


delete a permission for a bucket.

Path parameters for "delete a permission"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "delete a permission"

role

string
Permission role: user, client.

permission

string
Permission of resource: allow, deny.

action

string
Permission action: write, read.

HTTP response status codes for "delete a permission":

Code samples for "delete a permission":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/permissions"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get permissions for bucket


Gets all permissions for a bucket.

Path parameters for "Get permissions for bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Get permissions for bucket":

Code samples for "Get permissions for bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/permissions"

Response example

[ { "action": "write", "permission": "allow", "resource": "bucket/0000-0000-0000-0000", "role": "user" }]

Create a permission


Create a permission for a bucket.

Path parameters for "Create a permission"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create a permission"

Media Type:
application/json

action

string
required
example: write
No description

permission

string
required
example: allow
No description

role

string
example: user
No description

HTTP response status codes for "Create a permission":

Code samples for "Create a permission":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "action": "write", "permission": "allow", "role": "user"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/permissions"

Response example

{ "action": "write", "permission": "allow", "resource": "bucket/0000-0000-0000-0000", "role": "user"}

Update a permission


Update a permission for a bucket.

Path parameters for "Update a permission"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Update a permission"

Media Type:
application/json

action

string
required
example: write
No description

permission

string
required
example: allow
No description

role

string
example: user
No description

HTTP response status codes for "Update a permission":

Code samples for "Update a permission":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "action": "write", "permission": "allow", "role": "user"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/permissions"

Response example

{ "action": "write", "permission": "allow", "resource": "bucket/0000-0000-0000-0000", "role": "user"}

Get promotions for a bucket


Get promotions for a bucket

Path parameters for "Get promotions for a bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get promotions for a bucket"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

promotion_status

array
Promotion status, one or more can be specified. The default is all statuses.

promotion_filter

string
Filter to get only incoming/only outgoing promotions for a bucket. If nothing is specified, both, incoming and outgoing, promotions are returned

HTTP response status codes for "Get promotions for a bucket":

Code samples for "Get promotions for a bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/promote"

Response example

[ { "error": "string", "from_bucket_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "from_bucket_name": "string", "from_environment_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "from_environment_name": "string", "from_release_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "from_release_number": 0, "promotion_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "promotion_status": "Complete", "to_bucket_id": "d950657d-2b23-4907-9206-ead33ac17d7a", "to_bucket_name": "string", "to_environment_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "to_environment_name": "string", "to_release_id": "609a57d-b223-4507-9206-ca36ead03c6d" }]

Promote release between buckets


Promotes a release from one bucket to another.

Path parameters for "Promote release between buckets"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Promote release between buckets"

Media Type:
application/json

from_release

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

notes

string
If unset, the release notes of the "from release" will be used.

to_bucket

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

to_environment

string
example: b9a0657d-b223-4507-9206-ead33ac06c6d
If unset, the environment of the "from_release" will be used.

HTTP response status codes for "Promote release between buckets":

Code samples for "Promote release between buckets":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "from_release": "b9a0657d-b223-4507-9206-ead33ac06c6d", "notes": "string", "to_bucket": "b9a0657d-b223-4507-9206-ead33ac06c6d", "to_environment": "b9a0657d-b223-4507-9206-ead33ac06c6d"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/promote"

Response example

{ "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0}

Get information about the promotion job


Get information about the promotion job started from a bucket

Path parameters for "Get information about the promotion job"

bucketid

string
required
Bucket ID

promotionid

string
required
Promotion ID

projectid

string
required
Project ID

HTTP response status codes for "Get information about the promotion job":

Code samples for "Get information about the promotion job":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/promote/{promotionid}"

Response example

{ "error": "string", "from_bucket_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "from_bucket_name": "string", "from_environment_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "from_environment_name": "string", "from_release_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "from_release_number": 0, "promotion_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "promotion_status": "Complete", "to_bucket_id": "d950657d-2b23-4907-9206-ead33ac17d7a", "to_bucket_name": "string", "to_environment_id": "a9b0657d-b223-4075-9206-ead33ac06d6c", "to_environment_name": "string", "to_release_id": "609a57d-b223-4507-9206-ca36ead03c6d"}

Promote release asynchronously between buckets


Promotes a release asynchronously from one bucket to another.

Path parameters for "Promote release asynchronously between buckets"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Promote release asynchronously between buckets"

Media Type:
application/json

from_release

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

notes

string
If unset, the release notes of the "from release" will be used.

to_bucket

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

to_environment

string
example: b9a0657d-b223-4507-9206-ead33ac06c6d
If unset, the environment of the "from_release" will be used.

HTTP response status codes for "Promote release asynchronously between buckets":

Code samples for "Promote release asynchronously between buckets":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "from_release": "b9a0657d-b223-4507-9206-ead33ac06c6d", "notes": "string", "to_bucket": "b9a0657d-b223-4507-9206-ead33ac06c6d", "to_environment": "b9a0657d-b223-4507-9206-ead33ac06c6d"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/promoteasync"

Response example

{ "promotion_id": "b9a0657d-b223-4507-9206-ead33ac06c6d"}

Get release by badge


Gets a badged release for a given bucket.

Path parameters for "Get release by badge"

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

HTTP response status codes for "Get release by badge":

Code samples for "Get release by badge":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/release_by_badge/{badgename}"

Response example

{ "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0}

Get badged release entries


Gets all entries for a badged release.

Path parameters for "Get badged release entries"

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

Query parameters for "Get badged release entries"

label

string
Label

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

HTTP response status codes for "Get badged release entries":

Code samples for "Get badged release entries":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/release_by_badge/{badgename}/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get releases for bucket


Gets all releases for a given bucket.

Path parameters for "Get releases for bucket"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get releases for bucket"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

releasenum

string
release number

notes

string
Release notes

promoted_from_bucket

string
Bucket where release promoted from.

promoted_from_release

string
Release where release promoted from.

badges

string
Badge names.

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get releases for bucket":

Code samples for "Get releases for bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases"

Response example

[ { "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0 }]

Create release


Creates a new release for a given bucket. If you don't specify the snapshot or entries fields all entries currently in the bucket will be added to the release. Otherwise you can use the snapshot field to create a release with all entries prior to a given date, or the entries field to provide a list of entryids and versionids to add.

Path parameters for "Create release"

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create release"

Media Type:
application/json

entries

array[object]
No description

entryid

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

versionid

string
required
example: b9a0657d-b223-4507-9206-ead33ac06c6d
No description

metadata

object
No description

notes

string
No description

snapshot

string
example: 2017-07-21T17:32:28Z
No description

HTTP response status codes for "Create release":

Code samples for "Create release":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "entries": [ { "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" } ], "metadata": {}, "notes": "string", "snapshot": "2017-07-21T17:32:28Z"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases"

Response example

{ "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0}

Get release


Gets a single release for a given bucket.

Path parameters for "Get release"

bucketid

string
required
Bucket ID

releaseid

string
required
Release ID

projectid

string
required
Project ID

HTTP response status codes for "Get release":

Code samples for "Get release":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases/{releaseid}"

Response example

{ "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0}

Update release


Update fields on a single release for a given bucket.

Path parameters for "Update release"

bucketid

string
required
Bucket ID

releaseid

string
required
Release ID

projectid

string
required
Project ID

Request body for "Update release"

Media Type:
application/json

notes

string
No description

HTTP response status codes for "Update release":

Code samples for "Update release":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "notes": "string"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases/{releaseid}"

Response example

{ "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0}

Get release entries


Gets all entries for a single release.

Path parameters for "Get release entries"

bucketid

string
required
Bucket ID

releaseid

string
required
Release ID

projectid

string
required
Project ID

Query parameters for "Get release entries"

label

string
Label

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

HTTP response status codes for "Get release entries":

Code samples for "Get release entries":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases/{releaseid}/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get stats for a release


Get stats for a release for a given metric and time interval.

Path parameters for "Get stats for a release"

bucketid

string
required
Bucket ID

releaseid

string
required
Release ID

projectid

string
required
Project ID

Query parameters for "Get stats for a release"

metric

string
required
Select the metric for which you want the stats.

interval

string
required
Select the time interval for which you want the stats. day indicates last 24 hrs week indicates last 7 days month indicates last 30 days

HTTP response status codes for "Get stats for a release":

Code samples for "Get stats for a release":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases/{releaseid}/stats"

Response example

{ "quantity": 142312}

Get detail error information


Get the given number of latest errors in a release with their status code, timestamp and URL in a csv format

Path parameters for "Get detail error information"

bucketid

string
required
Bucket ID

releaseid

string
required
Release ID

projectid

string
required
Project ID

Query parameters for "Get detail error information"

per_page

integer
default: 10
Items Per Page

interval

string
required
Select the time interval for which you want the stats. day indicates last 24 hrs week indicates last 7 days month indicates last 30 days

HTTP response status codes for "Get detail error information":

Code samples for "Get detail error information":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/buckets/{bucketid}/releases/{releaseid}/stats/details/errors"

Response example

"Response_Status_Code,Submit_Time,URL\n404,2021-07-27 04:29:59.830 UTC,https://example.com/api/v1/endpoint\n403,2021-07-26 02:13:59.830 UTC,https://example.com/api/v1/endpoint"

Delete a bucket


Removes a bucket by ID. All files that are no longer referred to by another bucket in a project are removed.

Path parameters for "Delete a bucket"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Delete a bucket":

Code samples for "Delete a bucket":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get a bucket


Gets the bucket details by ID.

Path parameters for "Get a bucket"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Get a bucket":

Code samples for "Get a bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}"

Response example

{ "attributes": { "promote_only": true }, "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "created": "2024-01-01T00:00:00Z", "description": "Something that describes this bucket", "environment_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "environment_name": "test_environment", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "last_release": { "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0 }, "name": "android_staging", "permissions": { "bucket_promote": false, "bucket_read": true, "bucket_release": false, "bucket_write": false }, "private": true, "projectguid": "123e4567-e89b-12d3-a456-426655440000"}

Update a bucket


Updates the bucket details by ID.

Path parameters for "Update a bucket"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Update a bucket"

Media Type:
application/json

description

string
example: Something that describes this bucket
No description

name

string
example: android_staging
No description

HTTP response status codes for "Update a bucket":

Code samples for "Update a bucket":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "description": "Something that describes this bucket", "name": "android_staging"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}"

Response example

{ "attributes": { "promote_only": true }, "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "created": "2024-01-01T00:00:00Z", "description": "Something that describes this bucket", "environment_id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "environment_name": "test_environment", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "last_release": { "badges": [ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 } ], "changes": { "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5 }, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "entries_link": "string", "metadata": {}, "notes": "string", "promoted_from_bucket": "string", "promoted_from_release": "string", "releaseid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releasenum": 0 }, "name": "android_staging", "permissions": { "bucket_promote": false, "bucket_read": true, "bucket_release": false, "bucket_write": false }, "private": true, "projectguid": "123e4567-e89b-12d3-a456-426655440000"}

List bucket access tokens


List bucket access tokens.

Path parameters for "List bucket access tokens"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "List bucket access tokens"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

HTTP response status codes for "List bucket access tokens":

Code samples for "List bucket access tokens":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/accesstokens"

Response example

[ { "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string" }]

Create bucket access token


Create a bucket access token. By default, bucket access tokens grant access to all content in the bucket including all releases. To restrict access to a single release, specify a 'releaseid' in the post body.

Path parameters for "Create bucket access token"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create bucket access token"

Media Type:
application/json

description

string
example: Shared with internal devs
No description

releaseid

string
example: 123e4567-e89b-12d3-a456-426655440000
If not specified, the access token will be valid for all releases in the bucket.

HTTP response status codes for "Create bucket access token":

Code samples for "Create bucket access token":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "description": "Shared with internal devs", "releaseid": "123e4567-e89b-12d3-a456-426655440000"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/accesstokens"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Delete a bucket access token


Delete a bucket's access token by key.

Path parameters for "Delete a bucket access token"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

HTTP response status codes for "Delete a bucket access token":

Code samples for "Delete a bucket access token":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

get bucket access token


Get bucket access token info.

Path parameters for "get bucket access token"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

HTTP response status codes for "get bucket access token":

Code samples for "get bucket access token":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Update bucket access token info


Update bucket access token info.

Path parameters for "Update bucket access token info"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

tokenid

string
required
Token ID

projectid

string
required
Project ID

Request body for "Update bucket access token info"

Media Type:
application/json

description

string
example: Shared with internal devs
No description

HTTP response status codes for "Update bucket access token info":

Code samples for "Update bucket access token info":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "description": "Shared with internal devs"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/accesstokens/{tokenid}"

Response example

{ "created": "2024-01-01T00:00:00Z", "description": "string", "id": "b9a0657d-b223-4507-9206-ead33ac06c6d", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "token": "string"}

Get badges


Gets all badges for a bucket.

Path parameters for "Get badges"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get badges"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

name

string
resource name

releasenum

string
release number

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get badges":

Code samples for "Get badges":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/badges"

Response example

[ { "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0 }]

Assign a badge


Assigns a badge to a release.

Path parameters for "Assign a badge"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Assign a badge"

Media Type:
application/json

name

string
required
example: QATesting
No description

releaseid

string
example: 123e4567-e89b-12d3-a456-426655440000
No description

releasenum

integer
example: 2
No description

HTTP response status codes for "Assign a badge":

Code samples for "Assign a badge":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 2}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/badges"

Response example

{ "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0}

Delete a badge


Removes a badge by name.

Path parameters for "Delete a badge"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

HTTP response status codes for "Delete a badge":

Code samples for "Delete a badge":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/badges/{badgename}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get badge


Gets a badge by name.

Path parameters for "Get badge"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

badgename

string
required
Badge Name

projectid

string
required
Project ID

HTTP response status codes for "Get badge":

Code samples for "Get badge":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/badges/{badgename}"

Response example

{ "created": "2024-01-01T00:00:00Z", "created_by": "string", "created_by_name": "string", "name": "QATesting", "releaseid": "123e4567-e89b-12d3-a456-426655440000", "releasenum": 0}

Batch delete entries


Removes up to 200 entries from a given bucket. When DELETE is called on an entry we just mark it as deleted but all previous versions of the file still exist. No file content is removed.

Path parameters for "Batch delete entries"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Batch delete entries"

Media Type:
application/json
Array Type:
[ { "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

HTTP response status codes for "Batch delete entries":

Code samples for "Batch delete entries":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '[ { "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/batch/delete/entries"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Batch Create or Update Entries


Creates or update up to 200 entries in a given bucket via Signed URLs; Will update the entry if the path already exists. Content Hash and Content Size are not mandatory.

Path parameters for "Batch Create or Update Entries"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Batch Create or Update Entries"

Media Type:
application/json
Array Type:
[ { "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle" }]

HTTP response status codes for "Batch Create or Update Entries":

Code samples for "Batch Create or Update Entries":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '[ { "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle" }]' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/batch/entries"

Response example

[ { "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z" }]

Get counts of changes between releases


Gets the change count between two releases.

Path parameters for "Get counts of changes between releases"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get counts of changes between releases"

fromreleaseid

string
From Release ID, specify 'latest' to use the most recent release. Either fromreleaseid or fromreleasenum can be specified, but not both.

fromreleasenum

integer
From Release Number. To query against an empty bucket you may set fromreleasenum to zero. Either fromreleaseid or fromreleasenum can be specified, but not both.

toreleaseid

string
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

toreleasenum

integer
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

HTTP response status codes for "Get counts of changes between releases":

Code samples for "Get counts of changes between releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/diff/releases"

Response example

{ "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5}

Get changed entries between releases


Gets the list of changed entries between two releases.

Path parameters for "Get changed entries between releases"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get changed entries between releases"

fromreleaseid

string
From Release ID, specify 'latest' to use the most recent release. Either fromreleaseid or fromreleasenum can be specified, but not both.

fromreleasenum

integer
From Release Number. To query against an empty bucket you may set fromreleasenum to zero. Either fromreleaseid or fromreleasenum can be specified, but not both.

toreleaseid

string
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

toreleasenum

integer
To Release ID, when not specified the most recent state of the bucket will be used. Either toreleaseid or toreleasenum can be specified, but not both.

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

path

string
Path

include_states

array
Include change states, one or more can be specified. The default is all states.

content_type

string
content type

label

string
Label

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get changed entries between releases":

Code samples for "Get changed entries between releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/diff/releases/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get counts of changes since last release


Gets change count since the last release.

Path parameters for "Get counts of changes since last release"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

HTTP response status codes for "Get counts of changes since last release":

Code samples for "Get counts of changes since last release":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/diff/unreleased"

Response example

{ "add": 3, "delete": 1, "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "loading": true, "unchanged": 3, "update": 5}

Get changed entries since last releases


Gets changed entries since the last release.

Path parameters for "Get changed entries since last releases"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get changed entries since last releases"

page

integer
Current Page

per_page

integer
default: 10
Items Per Page

path

string
Path

include_states

array
Include change states, one or more can be specified. The default is all states.

label

string
Label

content_type

string
content type

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get changed entries since last releases":

Code samples for "Get changed entries since last releases":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/diff/unreleased/entries"

Response example

[ { "change_state": "Unchanged", "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 0, "content_type": "image/jpeg", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "updated_at": "2024-01-01T00:00:00Z", "versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d" }]

Get entries for bucket


Gets all entries for a given bucket. Entries can be searched/queried by path or label. For example, to search by path you can do "/buckets/{bucketid}/entries/?path=asset.bundle" To search by label you can do "/buckets/{bucketid}/entries/?label=android" To search by path and label both you can do "/buckets/{bucketid}/entries/?path=asset.bundle&label=android". In this case the entries will need to match both filters.

Path parameters for "Get entries for bucket"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Query parameters for "Get entries for bucket"

page

integer
Current Page

starting_after

string
returns items listed after the named ID

per_page

integer
default: 10
Items Per Page

path

string
Path

label

string
Label

content_type

string
content type

complete

boolean
is content upload completed or not

sort_by

string
Sort By

sort_order

string
Sort Order

HTTP response status codes for "Get entries for bucket":

Code samples for "Get entries for bucket":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries"

Response example

[ { "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z" }]

Create entry


Creates a new entry for a given bucket. Content Hash and Content Size are not mandatory when using Signed URLs.

Path parameters for "Create entry"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

projectid

string
required
Project ID

Request body for "Create entry"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

path

string
required
example: ios/character1.bundle
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Create entry":

Code samples for "Create entry":

Request example

curl -X POST \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "path": "ios/character1.bundle", "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Delete entry


Removes a single entry for a given bucket. When DELETE is called on an entry we just mark it as deleted but all previous versions of the file still exist. No file content is removed.

Path parameters for "Delete entry"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

HTTP response status codes for "Delete entry":

Code samples for "Delete entry":

Request example

curl -X DELETE \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Get entry


Gets a single entry for a given bucket.

Path parameters for "Get entry"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

HTTP response status codes for "Get entry":

Code samples for "Get entry":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Update entry


Updates a single entry for a given bucket.

Path parameters for "Update entry"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Request body for "Update entry"

Media Type:
application/json

content_hash

string
example: c76580fa26181bfa8d8952826bd334d5
The "content_hash" should be MD5sum hash value.

content_size

integer
example: 1234567
No description

content_type

string
example: image/jpeg
No description

labels

array[string]
No description

metadata

object
No description

signed_url

boolean
Set to 'true' if you want to return a signed URL for direct upload. Otherwise defaults to 'false'.

HTTP response status codes for "Update entry":

Code samples for "Update entry":

Request example

curl -X PUT \ -H "Content-Type: application/json" \ -d '{ "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_size": 1234567, "content_type": "image/jpeg", "labels": [ "string" ], "metadata": {}, "signed_url": true}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}"

Response example

{ "complete": true, "content_hash": "c76580fa26181bfa8d8952826bd334d5", "content_link": "string", "content_size": 1234567, "content_type": "image/jpeg", "current_versionid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "entryid": "b9a0657d-b223-4507-9206-ead33ac06c6d", "labels": [ "string" ], "last_modified": "2024-01-01T00:00:00Z", "last_modified_by": "string", "last_modified_by_name": "string", "link": "string", "metadata": {}, "path": "ios/character1.bundle", "signed_url": "string", "updated_at": "2024-01-01T00:00:00Z"}

Get content by entryid


Gets the content for a given entry.

Path parameters for "Get content by entryid"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Get content by entryid"

versionid

string
Version ID

HTTP response status codes for "Get content by entryid":

Code samples for "Get content by entryid":

Request example

curl -X GET \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

"string"

Get content status by entryid


Gets the status of uploaded content.

Path parameters for "Get content status by entryid"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Get content status by entryid"

versionid

string
Version ID

HTTP response status codes for "Get content status by entryid":

Code samples for "Get content status by entryid":

Request example

curl -X HEAD \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Upload content for entry


Uploads or resumes uploading content for an entry. There are two content-types supported for uploading content for an entry. One is "multipart/form-data" which is not available through the Internal API and the other is "application/offset+octet-stream" which uses the tus protocol. Please refer to https://tus.io/ for more details. Note that the Internal API also has a 100mb limitation. This API is now deprecated. We recommend using signed URLs as it uploads directly to the cloud storage and has no size limitations. Signed URLs are returned by the create and/or update entry endpoints by using the entry parameter signed_url set to "true".

Path parameters for "Upload content for entry"

environmentid

string
required
Environment ID

bucketid

string
required
Bucket ID

entryid

string
required
Entry ID

projectid

string
required
Project ID

Query parameters for "Upload content for entry"

versionid

string
Version ID

Request body for "Upload content for entry"

Media Type:
multipart/form-data

file

string
required
File content

HTTP response status codes for "Upload content for entry":

Code samples for "Upload content for entry":

Request example

curl -X PATCH \ -H "Content-Type: multipart/form-data" \ -d '{"file":"string"}' \ "https://services.api.unity.com/ccd/management/v1/projects/{projectid}/environments/{environmentid}/buckets/{bucketid}/entries/{entryid}/content"

Response example

{ "title": "Bad Request", "status": 400, "detail": "Something is wrong", "details": [ { "code": "ERROR_CODE_123", "path": "nested.value", "message": "Invalid value" } ], "requestId": "aad109f8-033f-4a24-8b77-5032eb3a6158"}

Create content upload for TUS


Simply returns the content upload URL in the Location header for TUS implementation. This endpoint is not required for most file uploads.

Path parameters for "Create content upload for TUS"

environmentid

[...]
